

function ___$insertStyle(css) {
    if (!css || typeof window === 'undefined') {
        return;
    }
    const style = document.createElement('style');
    style.setAttribute('type', 'text/css');
    style.innerHTML = css;
    document.head.appendChild(style);
    return css;
}

Object.defineProperty(exports, '__esModule', { value: true });

var index = require('./index-7e49c42e.js');
var index$1 = require('./index-3ade7882.js');
var React = require('react');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var notificationAction = (function (type, message) {
  var duration = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 7000;
  var types = {
    error: 'NOTIFICATION_TYPE_ERROR',
    warning: 'NOTIFICATION_TYPE_WARNING',
    success: 'NOTIFICATION_TYPE_SUCCESS',
    noInternet: 'NOTIFICATION_TYPE_NO_INTERNET'
  };
  return {
    type: 'ADD_NOTIFICATION',
    notification: {
      id: parseInt(Math.random().toString().split('.')[1], 10),
      duration: duration,
      message: message,
      type: types[type] || types.error,
      canDismiss: true
    }
  };
});

___$insertStyle(".alert-type {\n  font-size: 13px;\n  padding: 25px 35px;\n  max-width: 500px;\n  max-height: 250px;\n  box-shadow: 0 6px 4px -3px rgba(0, 0, 0, 0.2);\n  margin-bottom: 0 !important;\n  margin-left: 0 !important;\n}\n.alert-type > span {\n  line-height: 18px;\n}\n.alert-type.success {\n  color: #0a7c71;\n  background-color: #cff5f2;\n}\n.alert-type.info {\n  color: #2b6a94;\n  background-color: #daeffd;\n}\n.alert-type.error {\n  color: #933432;\n  background-color: #fddddd;\n}\n.alert-type .close {\n  background-color: transparent;\n  border: 0;\n  padding: 0;\n  float: right;\n  margin-left: 20px;\n  color: inherit;\n}\n.alert-type .close:before {\n  content: \"\\f00d\";\n  font-family: \"Font Awesome 5 Pro\";\n  font-weight: 900;\n  font-size: 14px;\n  color: inherit;\n  opacity: 0.6;\n}\n.alert-type .close:hover {\n  cursor: pointer;\n}\n.alert-type .close:hover:before {\n  opacity: 0.8;\n}");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = index.getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = index.getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return index.possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var Notification = /*#__PURE__*/function (_React$PureComponent) {
  index.inherits(Notification, _React$PureComponent);
  var _super = _createSuper(Notification);
  function Notification() {
    var _this;
    index.classCallCheck(this, Notification);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    index$1.defineProperty(index.assertThisInitialized(_this), "notificationParams", function (type, message) {
      if (type === 'NOTIFICATION_TYPE_WARNING') {
        return {
          classType: 'warning',
          message: message
        };
      }
      if (type === 'NOTIFICATION_TYPE_SUCCESS') {
        return {
          classType: 'success',
          message: message
        };
      }
      return {
        classType: 'error',
        message: message
      };
    });
    return _this;
  }
  index.createClass(Notification, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this$props = this.props,
        handleDismiss = _this$props.handleDismiss,
        id = _this$props.id,
        duration = _this$props.duration;
      if (duration !== 0) {
        setTimeout(function () {
          handleDismiss(id);
        }, duration);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
        handleDismiss = _this$props2.handleDismiss,
        propsMessage = _this$props2.message,
        type = _this$props2.type,
        id = _this$props2.id;
      var _this$notificationPar = this.notificationParams(type, propsMessage),
        classType = _this$notificationPar.classType,
        message = _this$notificationPar.message;
      if ('onLine' in navigator && !navigator.onLine) {
        return false;
      }
      return /*#__PURE__*/React__default["default"].createElement("div", {
        style: {
          transition: 'opacity 250ms ease 0s',
          opacity: 1
        }
      }, /*#__PURE__*/React__default["default"].createElement("div", {
        className: "".concat(classType, " alert-type"),
        style: {
          margin: 30
        }
      }, /*#__PURE__*/React__default["default"].createElement("button", {
        className: "close",
        onClick: function onClick() {
          return handleDismiss(id);
        }
      }), /*#__PURE__*/React__default["default"].createElement("span", null, message)));
    }
  }]);
  return Notification;
}(React__default["default"].PureComponent);
index$1.defineProperty(Notification, "defaultProps", {
  duration: 0,
  message: ''
});
index$1.defineProperty(Notification, "propTypes", {
  id: index.propTypes.number.isRequired,
  type: index.propTypes.string.isRequired,
  message: index.propTypes.oneOfType([index.propTypes.string, index.propTypes.object]),
  duration: index.propTypes.number,
  handleDismiss: index.propTypes.func.isRequired
});
Notification.displayName = "Notification";

exports.NotificationTemplate = Notification;
exports.notification = notificationAction;
