

function ___$insertStyle(css) {
    if (!css || typeof window === 'undefined') {
        return;
    }
    const style = document.createElement('style');
    style.setAttribute('type', 'text/css');
    style.innerHTML = css;
    document.head.appendChild(style);
    return css;
}

var index = require('./index-3ade7882.js');
var index$1 = require('./index-9411f9b2.js');

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

var arrayWithHoles = _arrayWithHoles;

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

var iterableToArrayLimit = _iterableToArrayLimit;

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var nonIterableRest = _nonIterableRest;

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || nonIterableRest();
}

var slicedToArray = _slicedToArray;

/**
 * lodash 3.0.1 (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright 2012-2016 The Dojo Foundation <http://dojofoundation.org/>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright 2009-2016 Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 * Available under MIT license <https://lodash.com/license>
 */

/**
 * Creates an array with all falsey values removed. The values `false`, `null`,
 * `0`, `""`, `undefined`, and `NaN` are falsey.
 *
 * @static
 * @memberOf _
 * @category Array
 * @param {Array} array The array to compact.
 * @returns {Array} Returns the new array of filtered values.
 * @example
 *
 * _.compact([0, 1, false, 2, '', 3]);
 * // => [1, 2, 3]
 */
function compact(array) {
  var index = -1,
      length = array ? array.length : 0,
      resIndex = 0,
      result = [];

  while (++index < length) {
    var value = array[index];
    if (value) {
      result[resIndex++] = value;
    }
  }
  return result;
}

var lodash_compact = compact;

var strictUriEncode = function (str) {
	return encodeURIComponent(str).replace(/[!'()*]/g, function (c) {
		return '%' + c.charCodeAt(0).toString(16).toUpperCase();
	});
};

function encoderForArrayFormat(opts) {
	switch (opts.arrayFormat) {
		case 'index':
			return function (key, value, index) {
				return value === null ? [
					encode(key, opts),
					'[',
					index,
					']'
				].join('') : [
					encode(key, opts),
					'[',
					encode(index, opts),
					']=',
					encode(value, opts)
				].join('');
			};

		case 'bracket':
			return function (key, value) {
				return value === null ? encode(key, opts) : [
					encode(key, opts),
					'[]=',
					encode(value, opts)
				].join('');
			};

		default:
			return function (key, value) {
				return value === null ? encode(key, opts) : [
					encode(key, opts),
					'=',
					encode(value, opts)
				].join('');
			};
	}
}

function parserForArrayFormat(opts) {
	var result;

	switch (opts.arrayFormat) {
		case 'index':
			return function (key, value, accumulator) {
				result = /\[(\d*)\]$/.exec(key);

				key = key.replace(/\[\d*\]$/, '');

				if (!result) {
					accumulator[key] = value;
					return;
				}

				if (accumulator[key] === undefined) {
					accumulator[key] = {};
				}

				accumulator[key][result[1]] = value;
			};

		case 'bracket':
			return function (key, value, accumulator) {
				result = /(\[\])$/.exec(key);
				key = key.replace(/\[\]$/, '');

				if (!result) {
					accumulator[key] = value;
					return;
				} else if (accumulator[key] === undefined) {
					accumulator[key] = [value];
					return;
				}

				accumulator[key] = [].concat(accumulator[key], value);
			};

		default:
			return function (key, value, accumulator) {
				if (accumulator[key] === undefined) {
					accumulator[key] = value;
					return;
				}

				accumulator[key] = [].concat(accumulator[key], value);
			};
	}
}

function encode(value, opts) {
	if (opts.encode) {
		return opts.strict ? strictUriEncode(value) : encodeURIComponent(value);
	}

	return value;
}

function keysSorter(input) {
	if (Array.isArray(input)) {
		return input.sort();
	} else if (typeof input === 'object') {
		return keysSorter(Object.keys(input)).sort(function (a, b) {
			return Number(a) - Number(b);
		}).map(function (key) {
			return input[key];
		});
	}

	return input;
}

var extract = function (str) {
	return str.split('?')[1] || '';
};

var parse = function (str, opts) {
	opts = index.objectAssign({arrayFormat: 'none'}, opts);

	var formatter = parserForArrayFormat(opts);

	// Create an object with no prototype
	// https://github.com/sindresorhus/query-string/issues/47
	var ret = Object.create(null);

	if (typeof str !== 'string') {
		return ret;
	}

	str = str.trim().replace(/^(\?|#|&)/, '');

	if (!str) {
		return ret;
	}

	str.split('&').forEach(function (param) {
		var parts = param.replace(/\+/g, ' ').split('=');
		// Firefox (pre 40) decodes `%3D` to `=`
		// https://github.com/sindresorhus/query-string/pull/37
		var key = parts.shift();
		var val = parts.length > 0 ? parts.join('=') : undefined;

		// missing `=` should be `null`:
		// http://w3.org/TR/2012/WD-url-20120524/#collect-url-parameters
		val = val === undefined ? null : decodeURIComponent(val);

		formatter(decodeURIComponent(key), val, ret);
	});

	return Object.keys(ret).sort().reduce(function (result, key) {
		var val = ret[key];
		if (Boolean(val) && typeof val === 'object' && !Array.isArray(val)) {
			// Sort object keys, not values
			result[key] = keysSorter(val);
		} else {
			result[key] = val;
		}

		return result;
	}, Object.create(null));
};

var stringify = function (obj, opts) {
	var defaults = {
		encode: true,
		strict: true,
		arrayFormat: 'none'
	};

	opts = index.objectAssign(defaults, opts);

	var formatter = encoderForArrayFormat(opts);

	return obj ? Object.keys(obj).sort().map(function (key) {
		var val = obj[key];

		if (val === undefined) {
			return '';
		}

		if (val === null) {
			return encode(key, opts);
		}

		if (Array.isArray(val)) {
			var result = [];

			val.slice().forEach(function (val2) {
				if (val2 === undefined) {
					return;
				}

				result.push(formatter(key, val2, result.length));
			});

			return result.join('&');
		}

		return encode(key, opts) + '=' + encode(val, opts);
	}).filter(function (x) {
		return x.length > 0;
	}).join('&') : '';
};

var queryString = {
	extract: extract,
	parse: parse,
	stringify: stringify
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { index.defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

// crud types
var CRUD_ACTION_REQUEST = 'CRUD_ACTION_REQUEST';
var CRUD_ACTION_SUCCESS = 'CRUD_ACTION_SUCCESS';
var CRUD_ACTION_FAILURE = 'CRUD_ACTION_FAILURE';
var RSAA = '@@redux-api-middleware/RSAA';

/**
 * Easy request to api server
 * @async
 * @param {Object} params
 * @param {string} [params.method=GET]
 * @param {string} params.endpoint
 * @param {Object} params.keys
 * @param {Object} query
 * @param {Object|Object[]} params.body
 * @param {Object} params.meta
 * @param {string} [params.name=base_]
 * @param {Object} params.headers
 * @returns {Promise} request result
 */
var crud = (function (_ref) {
  var _ref$method = _ref.method,
    method = _ref$method === void 0 ? 'GET' : _ref$method,
    endpoint = _ref.endpoint,
    keys = _ref.keys,
    _ref$query = _ref.query,
    query = _ref$query === void 0 ? {} : _ref$query,
    body = _ref.body,
    _ref$meta = _ref.meta,
    meta = _ref$meta === void 0 ? {} : _ref$meta,
    _ref$name = _ref.name,
    name = _ref$name === void 0 ? 'base_' : _ref$name,
    _ref$headers = _ref.headers,
    headers = _ref$headers === void 0 ? {} : _ref$headers,
    _ref$needToken = _ref.needToken,
    needToken = _ref$needToken === void 0 ? true : _ref$needToken,
    _ref$uploadFile = _ref.uploadFile,
    uploadFile = _ref$uploadFile === void 0 ? false : _ref$uploadFile,
    _ref$crudTypes = _ref.crudTypes,
    crudTypes = _ref$crudTypes === void 0 ? {
      request: "".concat(name, "_").concat(CRUD_ACTION_REQUEST),
      success: "".concat(name, "_").concat(CRUD_ACTION_SUCCESS),
      failure: "".concat(name, "_").concat(CRUD_ACTION_FAILURE)
    } : _ref$crudTypes,
    _ref$validStatuses = _ref.validStatuses,
    validStatuses = _ref$validStatuses === void 0 ? [] : _ref$validStatuses,
    _ref$errorMessagesByS = _ref.errorMessagesByStatus,
    errorMessagesByStatus = _ref$errorMessagesByS === void 0 ? {} : _ref$errorMessagesByS;
  var disableFilters = meta.disableFilters,
    _meta$requiredFilters = meta.requiredFilters,
    requiredFilters = _meta$requiredFilters === void 0 ? [] : _meta$requiredFilters;
  var metaObj = _objectSpread(_objectSpread({
    query: query
  }, meta), {}, {
    validStatuses: validStatuses,
    errorMessagesByStatus: errorMessagesByStatus
  });
  var action = index.defineProperty({
    needToken: needToken,
    isCrud: true
  }, RSAA, {
    endpoint: endpoint,
    method: method,
    types: [{
      type: crudTypes.request,
      meta: metaObj
    }, {
      type: crudTypes.success,
      meta: metaObj
    }, {
      type: crudTypes.failure,
      meta: function meta(actionFailure, state, res) {
        if (res) {
          return _objectSpread({
            status: res.status,
            statusText: res.statusText
          }, metaObj);
        }
        return {
          status: 'network'
        };
      }
    }]
  });
  if (!uploadFile) {
    action[RSAA].headers = _objectSpread({
      'Content-Type': 'application/json',
      'Cache-Control': 'no-store, no-cache, must-revalidate, proxy-revalidate, max-age=0'
    }, headers);
  } else {
    action[RSAA].headers = _objectSpread({}, headers);
  }
  if (keys) {
    Object.keys(keys).forEach(function (key) {
      action[RSAA].endpoint = action[RSAA].endpoint.replace(":".concat(key), keys[key]);
    });
  }
  if (query && Object.keys(query).length) {
    var compactedQuery = index$1.lodash_clonedeep(query);
    Object.entries(compactedQuery).forEach(function (_ref2) {
      var _ref3 = slicedToArray(_ref2, 2),
        key = _ref3[0],
        value = _ref3[1];
      var arr = Array.isArray(value) ? value : [value];
      compactedQuery[key] = lodash_compact(arr);
    });
    if (disableFilters && requiredFilters && requiredFilters.length) {
      Object.keys(compactedQuery).forEach(function (key) {
        if (requiredFilters.indexOf(key) < 0) {
          delete compactedQuery[key];
        }
      });
    }
    var queryString$1 = queryString.stringify(compactedQuery);
    if (queryString$1.length) {
      action[RSAA].endpoint = "".concat(action[RSAA].endpoint, "?").concat(queryString$1);
    }
  }
  if (body && action[RSAA].headers['Content-Type'] === 'application/json') {
    action[RSAA].body = JSON.stringify(body);
  } else if (body) {
    action[RSAA].body = body;
  }
  return action;
});

var addEvent = function addEvent(object, type, callback) {
  if (object == null || typeof object === 'undefined') return;
  if (object.addEventListener) {
    object.addEventListener(type, callback, false);
  } else if (object.attachEvent) {
    object.attachEvent("on".concat(type), callback);
  } else {
    object["on".concat(type)] = callback;
  }
};
var removeEvent = function removeEvent(object, type, callback) {
  if (object == null || typeof object === 'undefined') return;
  if (object.removeEventListener) {
    object.removeEventListener(type, callback, false);
  } else if (object.detachEvent) {
    object.detachEvent("on".concat(type), callback);
  } else {
    object["on".concat(type)] = null;
  }
};
var elemOffset = function elemOffset(elem) {
  var box = {
    top: 0,
    left: 0
  };
  var doc = elem && elem.ownerDocument;
  if (!doc) {
    return box;
  }
  var docElem = elem.ownerDocument.documentElement;
  box = elem.getBoundingClientRect();
  var win = window;
  return {
    top: box.top + (win.pageYOffset || docElem.scrollTop) - (docElem.clientTop || 0),
    left: box.left + (win.pageXOffset || docElem.scrollLeft) - (docElem.clientLeft || 0)
  };
};
var findByValue = function findByValue(obj, val, key) {
  var result = [];
  for (var outerKey in obj) {
    if (obj[outerKey][key] * 1 === val * 1) {
      result.push(outerKey);
    }
  }
  return result;
};
var getCookie = function getCookie(name) {
  var value = "; ".concat(document.cookie);
  var parts = value.split("; ".concat(name, "="));
  if (parts.length === 2) {
    return parts.pop().split(';').shift();
  }
  return undefined;
};

exports.CRUD_ACTION_FAILURE = CRUD_ACTION_FAILURE;
exports.CRUD_ACTION_REQUEST = CRUD_ACTION_REQUEST;
exports.CRUD_ACTION_SUCCESS = CRUD_ACTION_SUCCESS;
exports.addEvent = addEvent;
exports.crud = crud;
exports.elemOffset = elemOffset;
exports.findByValue = findByValue;
exports.getCookie = getCookie;
exports.lodash_compact = lodash_compact;
exports.queryString = queryString;
exports.removeEvent = removeEvent;
exports.slicedToArray = slicedToArray;
